
/*
 * 
 * $Log: help.h,v $
 * Revision 1.5  1993/06/28  20:28:59  wade
 * added conference and performance pointers
 *
 * Revision 1.4  1993/06/17  18:20:55  wade
 * changed version number
 *
 * Revision 1.3  1992/12/14  17:01:56  wade
 * set version to 3.3
 *
 * Revision 1.2  1992/12/05  17:27:42  larose
 * added rcs logging
 *
 *
 */

static char *HELP_FILE[] =  {
"\n",
"\n",
"                     Xnetlib - Ver 3.4\n",
"\n",
"           - an X interface to Netlib and the Na-Net Whitepages.  \n",
"\n",
"    TOP LEVEL BUTTONS\n",
"\n",
"    Go Up - Click to go back up a level in the library hierarchy. (cd ..)\n",
"\n",
"    Index - displays the general index for each active server.\n",
"\n",
"    Library - displays all toplevel netlib libraries.  Clicking on a library\n",
"          will display its description file. You may then select files for\n",
"          downloading or just poke around the hierarchy.\n",
"\n",
"    Classifications - A presorted set of subjects. Selecting one gives a\n",
"          subset of the general library list.\n",
"\n",
"    Search - allows the user to find routines by a keyword search.\n",
"\n",
"    Who - allows the user to perform a single word search on the NA-NET \n",
"          white pages.  \n",
"\n",
"    Download - allows you to download the selected software. This option\n",
"          is grayed out if no files are selected. The bottom window\n",
"          displays all files which have been selected for downloading.\n",
"          You may still select or unselect files before pressing\n",
"          'Get Files Now'.\n",
"\n",
"    Set Up - allows you to preload the index files from the server and\n",
"          add or remove xnetlib file servers from your list.\n",
"          See ALTERNATE SERVERS, below.\n",
"\n",
"    Conferences - search on a database of conferences.\n",
"\n",
"    Performance - examine a machine performance database.\n",
"\n",
"    Timely Message - look here for new additions to the library and other\n",
"          site specific notices for each active server.\n",
"\n",
"    Show in New Window - pops up a new window containing the text of the\n",
"          current screen.\n",
"\n",
"    Contextual Help - pops up (or down) a detailed help window which will\n",
"          change as you change modes.\n",
"\n",
"    Help - this screen.\n",
"\n",
"    Print - executes the print command using the text of the current screen.\n",
"\n",
"    Quit - exit xnetlib\n",
"\n",
"    INDEX FILES\n",
"\n",
"    The index files are stored locally in your xnlPath directory. These are\n",
"    the same files you might get by sending for the ndex by email from netlib.\n",
"\n",
"    X RESOURCES & COMMAND LINE OPTIONS\n",
"\n",
"    The command line option to set the resource appears in parentheses.\n",
"\n",
"    hostFile (-f,-file) Name of host file, The default is $Home/.xnetlibHosts\n",
"\n",
"    email (-email) Your prefered email address. Please set this value so you can be\n",
"          notified of updates to the software you get. If it isn't set, xnetlib\n",
"          tries to guess but will be wrong about 1/3rd of the time.\n",
"\n",
"    indexLifetime (-life) How long, in days, to use an index file before checking to\n",
"          see if it has expired.\n",
"\n",
"    entrySep (-es) the separator displayed between entries in the NA-NET white\n",
"          pages database. The default is '-------'.\n",
"\n",
"    printCommand (-pc) the format string for the print command. The string must\n",
"          contain a %s which is replaced with the name of the file which is\n",
"          printed. The default is 'lpr %s'.\n",
"\n",
"    showWhoInfo (-showwho,-noshowwho) whether to show instructions for adding\n",
"          your name to the NA-NET white pages database. The default is True.\n",
"\n",
"    xnlPath (-dp) path to the local xnetlib database. The default is $HOME/xnlData.\n",
"    \n",
"    publicData (-pub[lic],-nopub[lic]) if True, save index files world writeable.\n",
"          The default is False.\n",
"\n",
"    xnlDownloadPath (-path) path to directory where the files you select are\n",
"          downloaded. The default is $HOME/xnlFiles\n",
"\n",
"    depCheck (-dc,-nodc) if True then any files required by the items you explicitly\n",
"          request are downloaded also. The default is True.\n",
"\n",
"    showDownloadAnyway (-showdown,-noshowdown) if True then the Download button is\n",
"          not greyed out when there is nothing to download. The default is False.\n",
"\n",
"    confirmQuit (-cq,-nocq) if True you are asked if you truly want to exit when\n",
"          you press the Quit button. The default is False.\n",
"\n",
"    dontWarp (-dw) sometimes xnetlib tries to help you out by placing the cursor\n",
"          where it thinks you may want it. Set to True if you don't care for\n",
"          this type of behavior. The default is False.\n",
"        \n",
"    These colors affect the status window background:\n",
"\n",
"        okColor: the happy color, normally green\n",
"        badColor: the 'something's wrong' color, normally red\n",
"        cautionColor: the 'something's almost wrong' color, normally yellow\n",
"\n",
"    GAS GAUGE RESOURCES\n",
"\n",
"    These resources affect the gas guage widget in Download mode.\n",
"\n",
"        dial: the dial background color. The default is DarkViolet.\n",
"        needle: the indicator color. The default is yellow.\n",
"        ef: the color of the E and F. The default is red.\n",
"\n",
"\n",
"    ALTERNATE SERVERS\n",
"\n",
"    New to this version of Xnetlib is the ability to simultaneously\n",
"    communicate with more than one xnetlib server. At present there\n",
"    are three public servers in operation on the Internet. The first,\n",
"    here at Oak Ridge National Laboratory, one at the Ballistics\n",
"    Research Laboratory, and the other at Rice University in Texas.\n",
"    \n",
"    Here are the host names for those servers:\n",
"    \n",
"    netlib.ornl.gov\n",
"    netlib.brl.mil\n",
"    softlib.cs.rice.edu\n",
"    \n",
"    You can add and remove hosts from your active server list in\n",
"    'Set Up' mode.\n",
"    \n",
"    netlib.cs.utk.edu is not an xnetlib file server, you may notice\n",
"    that it is your default keyword and whois server. That is it's\n",
"    only function at present. You may add it to your active server list\n",
"    but nothing interesting will happen.\n",
"\n",
"    We are not yet ready to release the xnetlib server code. We expect to do so\n",
"    in a few months. Send mail to xnetlib@cs.utk.edu for more information.\n",
"\n",
"    LIBRARY INDEX FILE ERRORS\n",
"\n",
"    Some index files may be broken, if a file is not listed in the\n",
"    an index or shown but not selectable then the index file for\n",
"    that library is broken. Please send mail to xnetlib@cs.utk.edu\n",
"    giving as much detail as possible if you come across something like this.\n",
"\n",
"    MOVEMENT KEYS\n",
"\n",
"    You can scroll up and down in a text window more easily by using the\n",
"    up and down arrow keys and the spacebar.\n",
"\n",
"      Space       down 1 line          ctrl-Space        up 1 line\n",
"      Up Arrow    up 1 page            ctrl-Up Arrow     go to beginning\n",
"      Down Arrow  down 1 page          ctrl-Down Arrow   go to end\n",
"\n",
"    A NOTE ABOUT SELECTING TEXT\n",
"\n",
"    The usual mouse button bindings for selecting text to paste into another\n",
"    window could not be used as the left button is reserved for file and\n",
"    library selection.\n",
"\n",
"    You may still use button 3 (usually the rightmost button) to drag over\n",
"    an area to select text. Unfortunately, parts of a single line may not\n",
"    be selected.\n",
"\n",
"    BUG REPORTS\n",
"\n",
"    Please send bug reports and comments or suggestions for improvements\n",
"    to the xnetlib software to xnetlib@cs.utk.edu. Problems installing or\n",
"    using packages in the netlib repository should be directed to the\n",
"    original authors.\n",
"\n",
"    For bug reports please include as much information as possible\n",
"    about your system including: vendor and model, OS version,\n",
"    what flavor of X you are using, make logs, etc.\n",
"\n",
"    Thanks\n",
"\n",
NULL };
